#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.2.6.0
 Script Version: 1.02
 Author:         Claude Hohl
 E-Mail:		 controlspace@longneck.ch

 Script Function:
	Automate _everything_ with one hotkey-combination: CONTROL-SPACE.
	Define commands for every window individually in the configuration file "space.control".
	ControlSpace will display buttons for each command. (Max 10 commands each window)

 History:
	05.09.2007 - Beta test & personal use
	24.10.2007 - Fading buttons at startup, documentation, testing
	25.10.2007 - Release
	26.10.2007 - Added timeout option to wwa, made GUI "bullet-proof"

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here

Opt("WinTitleMatchMode", 2)
Opt("SendKeyDelay", 1)

#include <Array.au3>
#include <File.au3>
#include "GUIEnhance.au3"

FileInstall("control.jpg", @TempDir & "\control.jpg", 1)
FileInstall("space.jpg", @TempDir & "\space.jpg", 1)
FileInstall("space.control", "space.control", 0)	

TrayTip("ControlSpace", "Version 1.02", 0, 0)

HotKeySet("^{SPACE}", "controlspace")
HotKeySet("^!{SPACE}", "spacecontrol")
;HotKeySet("{F5}", "schluss")

Func schluss()
	Exit
EndFunc


Dim $line
Dim $windows
Dim $filetime = FileGetTime("space.control", 0, 1)

_FileReadToArray("space.control", $line)

$control = GUICreate("", 200, 120, 20, @DesktopHeight - 200, $WS_POPUP, $WS_EX_TOOLWINDOW)
GUICtrlCreatePic(@TempDir & "\control.jpg", 0, 0, 200, 120)
$space = GUICreate("", 316, 120, 250, @DesktopHeight - 200, $WS_POPUP, $WS_EX_TOOLWINDOW)
GUICtrlCreatePic(@TempDir & "\space.jpg", 0, 0, 316, 120)
_GUIEnhanceAnimateWin($control, 500, $GUI_EN_ANI_FADEIN)
_GUIEnhanceAnimateWin($space, 500, $GUI_EN_ANI_FADEIN)
Sleep(1500)
_GUIEnhanceAnimateWin($control, 1000, $GUI_EN_ANI_FADEOUT)
_GUIEnhanceAnimateWin($space, 500, $GUI_EN_ANI_FADEOUT)

While 1
	
	Sleep(10000)
	
WEnd


Func controlspace()
	
	$windows = getwindows()
	
	Local $winid = 0
	Local $amax = UBound($windows)
	Local $windowfound = 0
	
	While $winid < $amax
		
		If WinActive($windows[$winid]) Then ;Fenster in der Config gefunden
			
			$windowfound = 1
			
			$buttons = getbuttons($windows[$winid])
			
			If UBound($buttons) > 0 And $buttons[0] <> "" Then
				
				Dim $guibuttons[1]
				
				Local $i = 0
				Local $gbmax = UBound($buttons)
				While $i < $gbmax
					_ArrayAdd($guibuttons, $windows[$winid] & $buttons[$i])
					$i = $i + 1
					If $i >= 10 Then ExitLoop ;Maximal 10 Buttons im GUI...
				WEnd
				_ArrayDelete($guibuttons, 0)
				
				;Auffllen bis 10
				While $i < 10
					_ArrayAdd($guibuttons, "")
					$i = $i + 1
				WEnd
				
				
				;Get _All Buttons				
				If _ArraySearch($windows, "_All") <> -1 Then
					
					$allbuttons = getbuttons("_All")
					
					If UBound($allbuttons) > 0 And $allbuttons[0] <> "" Then
						
						Local $fi = 9
						Local $ai = 0
						Local $aimax = UBound($allbuttons)
						While $ai < $aimax
							If $guibuttons[$fi] == "" Then
								$guibuttons[$fi] = "_All" & $allbuttons[$ai]
							EndIf
							$fi = $fi - 1
							$ai = $ai + 1
						WEnd
						
					EndIf
					
				EndIf
				
				Global $hotkeybuttons = $guibuttons
				creategui($guibuttons)
				
			Else
				
				$actions = getactions($windows[$winid], "")
				$nbai = 0
				$nbamax = UBound($actions)
				While $nbai < $nbamax
					interpret($actions[$nbai])
					$nbai = $nbai + 1
				WEnd
				
			EndIf
			
		EndIf
		
		$winid = $winid + 1
		
	WEnd
	
	If $windowfound == 0 Then
		
		;Get _All Buttons				
		If _ArraySearch($windows, "_All") <> -1 Then
			
			Dim $guibuttons[1]
			
			;Auffllen bis 10
			Local $x = 0
			While $x < 10
				_ArrayAdd($guibuttons, "")
				$x = $x + 1
			WEnd
			
			$allbuttons = getbuttons("_All")
			
			Local $fi = 10
			Local $ai = 0
			Local $aimax = UBound($allbuttons)
			While $ai < $aimax
				$guibuttons[$fi] = "_All" & $allbuttons[$ai]
				$fi = $fi - 1
				$ai = $ai + 1
			WEnd
			
			_ArrayDelete($guibuttons, 0)
			
			Global $hotkeybuttons = $guibuttons
			creategui($guibuttons)
			
		EndIf
		
	EndIf
	
EndFunc


Func gettype($line)
	
	If $line <> "" Then
		
		If StringRegExp($line, "^\t{0,0}[^\t]") Then
			Return "w"
		EndIf
		
		If StringRegExp($line, "^\t{1,1}[^\t]") Then
			Return "b"
		EndIf
		
		If StringRegExp($line, "^\t{2,2}[^\t]") Then
			Return "a"
		EndIf
		
	EndIf
	
EndFunc


Func getindex($array, $whattosearch)
	
	Local $i = 0
	Local $amax = UBound($array)
	While $i < $amax
		If StringCompare($array[$i], $whattosearch) = 0 Then
			Return $i
		EndIf
		$i = $i + 1
	WEnd
	
EndFunc


Func d($title, $msg, $pause = 300)
	
	SplashTextOn("", $title & ": " & $msg, 800, 200, @DesktopWidth - 800, @DesktopHeight - 300, 1)
	Sleep($pause)
	
EndFunc


Func getwindows()
	
	Dim $windows[1]
		
	Local $i = 1
	$asize = UBound($line)
	While $i < $asize
		
		If gettype($line[$i]) == "w" Then
				_ArrayAdd($windows, $line[$i])
		EndIf
			
		$i = $i + 1
		
	WEnd
	
	_ArrayDelete($windows, 0)
	
	Return $windows
	
EndFunc


Func getwindowblock($wintitle)
	
	$currentwinindex = getindex($line, $wintitle)
	$currentindex_winblock = getindex($windows, $wintitle)
	
	If $currentindex_winblock+1 == UBound($windows) Then
		$afterwinindex = UBound($line)
	Else
		$afterwin_winblock = $windows[$currentindex_winblock+1]
		$afterwinindex = getindex($line, $afterwin_winblock)
	EndIf
	
	Local $i = $currentwinindex
	Local $windowblock[1]
	While $i < $afterwinindex
		If $line[$i] <> "" Then
			_ArrayAdd($windowblock, $line[$i])
		EndIf
		$i = $i + 1
	WEnd
	
	_ArrayDelete($windowblock, 0)
	
	Return $windowblock
	
EndFunc


Func getbuttons($wintitle)
	
	Local $wblock = getwindowblock($wintitle)
	
	Local $buttons[1]
	
	Local $i = 1
	Local $max = UBound($wblock)
	While $i < $max
		
		If gettype($wblock[$i]) == "b" Then
			_ArrayAdd($buttons, $wblock[$i])
		EndIf
		
		$i = $i + 1
		
	WEnd
	
	_ArrayDelete($buttons, 0)
	
	Return $buttons
	
EndFunc


Func getactions($wintitle, $button)
	
	Local $action[1]
	
	Local $buttons = getbuttons($wintitle)
	
	_ArrayDelete($action, 0)
	
	Local $wblock = getwindowblock($wintitle)
	
	Local $i = 1
	Local $amax = UBound($wblock)
	While $i < $amax
		
		If (StringInStr($wblock[$i], $button)) Or (gettype($wblock[$i]) == "a" And UBound($buttons) == 1 And $buttons[0] == "") Then
			
			$i = $i + 1 ;Zhler rauf, der erste Eintrag ist ja ein Button!
			
			If UBound($buttons) == 1 And $buttons[0] == "" Then ;Keine Buttons: Zhler doch wieder runter
				$i = $i - 1
			EndIf
			
			_ArrayAdd($wblock, 0) ;Workaround, damit der Zhler nicht auf die Fresse fliegt (out of range)
			
			While gettype($wblock[$i]) == "a"
				_ArrayAdd($action, $wblock[$i])
				$i = $i + 1
			WEnd
			
			_ArrayDelete($action, 0)
			
			ExitLoop
			
		EndIf
		
		$i = $i + 1
		
	WEnd
	
	Return $action
	
EndFunc


Func interpret($command)
	
	HotKeySet("^{SPACE}", "controlspace")
	
	$command = StringRegExpReplace($command, "^\t+", "")
	
	$c = StringSplit($command, "	")
	
	If $c[0] < 3 Then
		_ArrayAdd($c, 0)
	EndIf
	
	#cs ----------------
	$c[1]: Command
	$c[2]: Parameter 1
	$c[3]: Parameter 2
	#ce ----------------
	
	Select
		
	Case $c[1] == "send"
		Send($c[2])
		
	Case $c[1] == "sleep"
		Sleep($c[2])
		
	Case $c[1] == "wa"
		WinSetState($c[2], "", @SW_MAXIMIZE)
		WinActivate($c[2])
		
	Case $c[1] == "rxr"
		$clip = ClipGet()
		$clip = StringRegExpReplace($clip, $c[2], $c[3])
		ClipPut($clip)
		
	Case $c[1] == "run"
		Run($c[2])
		
	Case $c[1] == "wwa"
		WinWaitActive($c[2], "", $c[3])
		
	Case $c[1] == "trans"
		$trans = 255 / 100 * $c[2]
		WinSetTrans("", "", $trans)
		
	Case $c[1] == "ontop"
		WinSetOnTop("", "", 1)
		
	Case $c[1] == "notop"
		WinSetOnTop("", "", 0)
		
	EndSelect
		
EndFunc


Func creategui($buttons)
	
	HotKeySet("^{SPACE}")
	
	$relevant_buttons = 0
	$ri = 0
	While $ri < 10
		If $buttons[$ri] <> "" Then
			$relevant_buttons = $relevant_buttons + 1
		EndIf
		$ri = $ri + 1
	WEnd
	$relevant_buttons = $relevant_buttons
	
	$pos = MouseGetPos()
	GUICreate("HUD", 300, 30 * $relevant_buttons, $pos[0], $pos[1], $WS_POPUP, $WS_EX_TOOLWINDOW)
	GUISetState(@SW_SHOW)
	
	;AutoIt cannot handle buttons in an array - that sucks! Sorry guys...
	
	Local $b0 = 1, $b1 = 1, $b2 = 1, $b3 = 1, $b4 = 1, $b5 = 1, $b6 = 1, $b7 = 1, $b8 = 1, $b9 = 1
	
	$hpos = 0
	
	If $buttons[0] <> "" Then
		$buttonname = StringSplit($buttons[0], "	")
		$buttonname = $buttonname[2]
		$b0 = GUICtrlCreateButton("0: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD0}", "b0")
		$hpos = $hpos + 30
	EndIf
	
	If $buttons[1] <> "" Then
		$buttonname = StringSplit($buttons[1], "	")
		$buttonname = $buttonname[2]
		$b1 = GUICtrlCreateButton("1: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD1}", "b1")
		$hpos = $hpos + 30
	EndIf
	
	If $buttons[2] <> "" Then
		$buttonname = StringSplit($buttons[2], "	")
		$buttonname = $buttonname[2]
		$b2 = GUICtrlCreateButton("2: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD2}", "b2")
		$hpos = $hpos + 30
	EndIf
	
	If $buttons[3] <> "" Then
		$buttonname = StringSplit($buttons[3], "	")
		$buttonname = $buttonname[2]
		$b3 = GUICtrlCreateButton("3: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD3}", "b3")
		$hpos = $hpos + 30
	EndIf
	
	If $buttons[4] <> "" Then
		$buttonname = StringSplit($buttons[4], "	")
		$buttonname = $buttonname[2]
		$b4 = GUICtrlCreateButton("4: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD4}", "b4")
		$hpos = $hpos + 30
	EndIf
	
	If $buttons[5] <> "" Then
		$buttonname = StringSplit($buttons[5], "	")
		$buttonname = $buttonname[2]
		$b5 = GUICtrlCreateButton("5: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD5}", "b5")
		$hpos = $hpos + 30
	EndIf
	
	If $buttons[6] <> "" Then
		$buttonname = StringSplit($buttons[6], "	")
		$buttonname = $buttonname[2]
		$b6 = GUICtrlCreateButton("6: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD6}", "b6")
		$hpos = $hpos + 30
	EndIf
	
	If $buttons[7] <> "" Then
		$buttonname = StringSplit($buttons[7], "	")
		$buttonname = $buttonname[2]
		$b7 = GUICtrlCreateButton("7: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD7}", "b7")
		$hpos = $hpos + 30
	EndIf
	
	If $buttons[8] <> "" Then
		$buttonname = StringSplit($buttons[8], "	")
		$buttonname = $buttonname[2]
		$b8 = GUICtrlCreateButton("8: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD8}", "b8")
		$hpos = $hpos + 30
	EndIf
	
	If $buttons[9] <> "" Then
		$buttonname = StringSplit($buttons[9], "	")
		$buttonname = $buttonname[2]
		$b9 = GUICtrlCreateButton("9: " & $buttonname, 0, $hpos, 300, 30)
		HotKeySet("{NUMPAD9}", "b9")
		$hpos = $hpos + 30
	EndIf
	
	
	While 1
		
		$msg = GUIGetMsg()
		
		Select
			
			Case $msg = $GUI_EVENT_CLOSE
				GUIDelete()
				unsethotkeys()
				HotKeySet("^{SPACE}", "controlspace")
				ExitLoop
			
			Case $msg = $b0
				
				GUIDelete()
				
				$command = StringSplit($buttons[0], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
			Case $msg = $b1
				
				GUIDelete()
				
				$command = StringSplit($buttons[1], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
			Case $msg = $b2
				
				GUIDelete()
				
				$command = StringSplit($buttons[2], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
			Case $msg = $b3
				
				GUIDelete()
				
				$command = StringSplit($buttons[3], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
			Case $msg = $b4
				
				GUIDelete()
				
				$command = StringSplit($buttons[4], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
			Case $msg = $b5
				
				GUIDelete()
				
				$command = StringSplit($buttons[5], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
			Case $msg = $b6
				
				GUIDelete()
				
				$command = StringSplit($buttons[6], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
			Case $msg = $b7
				
				GUIDelete()
				
				$command = StringSplit($buttons[7], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
			Case $msg = $b8
				
				GUIDelete()
				
				$command = StringSplit($buttons[8], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
			Case $msg = $b9
				
				GUIDelete()
				
				$command = StringSplit($buttons[9], "	")
				$actions = getactions($command[1], $command[2])
				
				Local $ri = 0
				Local $rmax = UBound($actions)
				While $ri < $rmax
					interpret($actions[$ri])
					$ri = $ri + 1
				WEnd
				
				unsethotkeys()
				
				ExitLoop
			
		EndSelect
		
	WEnd
	
EndFunc


Func unsethotkeys()
	
	HotKeySet("{NUMPAD0}")
	HotKeySet("{NUMPAD1}")
	HotKeySet("{NUMPAD2}")
	HotKeySet("{NUMPAD3}")
	HotKeySet("{NUMPAD4}")
	HotKeySet("{NUMPAD5}")
	HotKeySet("{NUMPAD6}")
	HotKeySet("{NUMPAD7}")
	HotKeySet("{NUMPAD8}")
	HotKeySet("{NUMPAD9}")
	
EndFunc


Func b0()
	
	GUIDelete()

	$command = StringSplit($hotkeybuttons[0], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc

Func b1()
	
	GUIDelete()
	
	$command = StringSplit($hotkeybuttons[1], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc

Func b2()
	
	GUIDelete()
	
	$command = StringSplit($hotkeybuttons[2], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc

Func b3()
	
	GUIDelete()
	
	$command = StringSplit($hotkeybuttons[3], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc

Func b4()
	
	GUIDelete()
	
	$command = StringSplit($hotkeybuttons[4], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc

Func b5()
	
	GUIDelete()
	
	$command = StringSplit($hotkeybuttons[5], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc

Func b6()
	
	GUIDelete()
	
	$command = StringSplit($hotkeybuttons[6], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc

Func b7()
	
	GUIDelete()
	
	$command = StringSplit($hotkeybuttons[7], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc

Func b8()
	
	GUIDelete()
	
	$command = StringSplit($hotkeybuttons[8], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc

Func b9()
	
	GUIDelete()
	
	$command = StringSplit($hotkeybuttons[9], "	")
	$actions = getactions($command[1], $command[2])
	
	Local $ri = 0
	Local $rmax = UBound($actions)
	While $ri < $rmax
		interpret($actions[$ri])
		$ri = $ri + 1
	WEnd
	
	unsethotkeys()
	
EndFunc


Func spacecontrol()
	
	Run(@WindowsDir & "\NOTEPAD.EXE space.control")
	WinWaitActive("space.control")
	WinWaitClose("space.control")
	_FileReadToArray("space.control", $line)
	TrayTip("ControlSpace", "Config file changed, reload complete", 5, 1)
	
EndFunc





























































































